document.addEventListener("DOMContentLoaded", () => {
    chrome.storage.local.get(["activeElement"], (result) => {
        if (result.activeElement) {
            window.targetElementData = result.activeElement;
            //alert("ストレージから取得した activeElement: " + JSON.stringify(window.targetElementData));
        } else {
            alert("アクティブ要素がストレージに見つかりませんでした");
            window.close(); // ストレージにデータがなければポップアップを閉じる
        }
    });

    document.getElementById("btn1").addEventListener("click", () => handleInsert("はじめまして"));
    document.getElementById("btn2").addEventListener("click", () => handleInsert("こんにちわ"));
    document.getElementById("btn3").addEventListener("click", () => handleInsert("続けて"));
    document.getElementById("closeBtn").addEventListener("click", () => window.close());
});

function handleInsert(text) {
    if (window.targetElementData) {
        chrome.tabs.query({ active: true, currentWindow: true }, (tabs) => {
            if (tabs.length === 0) {
                alert("アクティブなタブが見つかりません");
                return;
            }
            const activeTabId = tabs[0].id;
            chrome.scripting.executeScript({
                target: { tabId: activeTabId, allFrames: true },
                function: insertTextInActiveField,
                args: [window.targetElementData, text]
            }, (results) => {});
            window.close();
        });
    } else {
        window.close();
    }
}

function insertTextInActiveField(elementData, insertText) {

    let targetElement = null;

    if (elementData.id) {
        targetElement = document.querySelector("#" + elementData.id);
    } else if (elementData.name) {
        targetElement = document.querySelector("[name='" + elementData.name + "']");
    }

    if (!targetElement && elementData.tagName) {
        const elements = document.querySelectorAll(elementData.tagName);
        targetElement = elements[elementData.index] || null;
    }

    if (targetElement) {
        targetElement.focus();
        if (targetElement.tagName === "INPUT" || targetElement.tagName === "TEXTAREA") {
            targetElement.value += insertText;
        } else if (targetElement.isContentEditable) {
            targetElement.innerText += insertText;
        }
        return true;  // 成功したら処理終了
    }
    return false;  // 成功したら処理終了
}
// スタイルの調整
document.addEventListener("DOMContentLoaded", () => {
    const style = document.createElement("style");
    style.innerHTML = `
        body {
            width: 200px;
            padding: 10px;
        }
        button {
            display: block;
            width: 100%;
            margin: 5px 0;
            padding: 8px;
            font-size: 14px;
        }
        #closeBtn {
            background-color: red;
            color: white;
            width: 100%;
            display: block;
            padding: 8px;
            border: none;
            cursor: pointer;
        }
    `;
    document.head.appendChild(style);
});
